=== debian/changelog ===
descent3 (1.6.0~20250615+ds-1) experimental; urgency=low

  * New GIT snapshot.
    + Use SDL3
  * d/control: build-depends on libcpp-httplib-dev, libplog-dev and libsdl3-dev

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 05 Oct 2025 11:20:13 +0200
